﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

using System.Windows.Media.Imaging;
using System.IO;

namespace AdvancedBitmaps
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "JPEG Files (*.jpg;*.jpeg)|*.jpg;*.jpeg | All Files (*.*)|*.*";
            ofd.FilterIndex = 1;
            bool? result = ofd.ShowDialog();
            if (result == true)
            {
                Stream stream = ofd.File.OpenRead();
                BitmapImage bi = new BitmapImage();

                bi.SetSource(stream);

                image1.Source = bi;

                stream.Close();
                image1.Source = bi;

            }
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            BitmapImage bit1 = new BitmapImage(
             new Uri("/test.jpg", UriKind.Relative));
            bit1.ImageOpened += new EventHandler<RoutedEventArgs>(img_ImageOpened);
            bit1.CreateOptions = BitmapCreateOptions.None;

        }
        private void img_ImageOpened(object sender, RoutedEventArgs e)
        {

            WriteableBitmap wbm = new WriteableBitmap((BitmapSource)sender);

            image1.Source = wbm;

        }

        private void button3_Click(object sender, RoutedEventArgs e)
        {
            Line myLine = new Line();
            myLine.X1 = 1;
            myLine.X2 = 50;
            myLine.Y1 = 1;
            myLine.Y2 = 50;
            myLine.Stroke = new SolidColorBrush(Colors.Black);
            WriteableBitmap wbm = new WriteableBitmap(100, 100);
            wbm.Render(myLine, null);
            wbm.Render(new Line() { X1 = 0, Y1 = 50, X2 = 50, Y2 = 0, Stroke = new SolidColorBrush(Colors.Black) }, null);
            //Clear to black
            //wbm.Render(new Rectangle() { Width = wbm.PixelWidth, Height = wbm.PixelHeight, Fill = new SolidColorBrush(Colors.Black) }, null);
            wbm.Render(button1, null);
            TextBlock message = new TextBlock();
            message.Text = "Hello Dynamic Text";
            wbm.Render(message, null);
            image1.Source = wbm;
            wbm.Invalidate();

        }

        private void button4_Click(object sender, RoutedEventArgs e)
        {
            WriteableBitmap wbm = new WriteableBitmap(100, 100);
            for (int x = 0; x < 100; x+=3)
            {
                wbm.Render(new Line() { X1 = 0, Y1 = 0, X2 = x, Y2 = 99, Stroke = new SolidColorBrush(Colors.Black) }, null);
            }

            for (int y = 0; y < 100; y+=5)
            {
                wbm.Render(new Line() { X1 = 0, Y1 = 0, X2 = 99, Y2 = y, Stroke = new SolidColorBrush(Colors.Black) }, null);
            }
            image1.Source = wbm;
            wbm.Invalidate();
        }
    }
}
